package br.com.linx.sisdia.fiscal.sped;

import java.io.PrintStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 
 * Gera os registros I200 e I250 do Sped1000
 * 
 * @author ricardo.xavier
 *
 */
public class Balancete extends CmdSped {

	private Date data;
	private String conta;
	private String cCusto;
	private double debitos;
	private double creditos;
	
	private List<Registro> registros;
	private int idx200 = -1;
	private String arLc;
	private int ocorr;

	private DateFormat dfSaida = new SimpleDateFormat("ddMMyyyy");
	
	private Connection bd;
	private Map<String, RegistroTmp> mapaTmp;
	private Map<String, String> mapaPlano;
	private Map<Integer, Boolean> mapaEstorno1;
	private Map<Integer, Boolean> mapaEstorno2;
	
	private String finalizador;
	private PrintStream log;
	
	// jdbc:informix-sqli://A-SRVBH012:30070/sisdia:informixserver=ol_dasjd01;Client_Locale=pt_br.8859-1;;user=tomcat;password=703kg7d14 
	// 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,100 
	// 01/01/2018 
	// 31/12/2018 
	// 1
	// 1
	// G
	// 1
	// A
	public static void main(String[] args)
			throws Exception {

		if (args.length != 9) {
			System.out.println("Uso: Balancete <url> <filiais> <dataIni> <dataFim> <codEmpresa> <tipo> <identificacao> <ocorr> <mascConta>");
			return;
		}
		
		DateFormat dfBarras = new SimpleDateFormat("dd/MM/yyyy");

		// argumentos
		String url = args[0];
		String filiais = args[1];
		Date dataIni = dfBarras.parse(args[2]);
		Date dataFim = dfBarras.parse(args[3]);
		int codEmpresa = Integer.parseInt(args[4]);
		int tipo = Integer.parseInt(args[5]);
		String identificacao = args[6];
		int ocorr = Integer.parseInt(args[7]);
		String mascConta = args[8];
		
		Balancete bal = new Balancete();
		bal.setComando("balancete");
		bal.gera(url, filiais, dataIni, dataFim, codEmpresa, tipo, identificacao, ocorr, mascConta);

	}	

	public void gera(String url, String filiais, Date dataIni, Date dataFim, int codEmpresa, int tipo, String identificacao, int _ocorr, String mascConta)
			throws Exception {

		if ((tipo == 3) || (tipo == 4)) {
			return;
		}
		
		finalizador = ((tipo == 9) || (tipo == 10)  || (tipo == 11)) ? "||" : "|";
		
		this.ocorr = _ocorr;

		try {

			bd = conectaBanco(url);
			
			int contador = 0;
			DateFormat df = new SimpleDateFormat("ddmmyyyy");
			
			Map<String, Balancete> mapa = new HashMap<String, Balancete>();
			mapaPlano = new HashMap<String, String>();
			mapaEstorno1 = new HashMap<Integer, Boolean>();
			mapaEstorno2 = new HashMap<Integer, Boolean>();
			mapaTmp = new HashMap<String, RegistroTmp>();
			registros = new ArrayList<Registro>();
			
			carregaDiretorio(bd, codEmpresa);
			log = new PrintStream(getDiretorio() + "balancete.log");

			// mostra o numero de registros da tmp_plano no log
			int countTmp = 0;
			String sqlAux = "select count(*) from tmp_plano "; 
			Statement stmtAux = bd.createStatement();
			ResultSet cursorAux = stmtAux.executeQuery(sqlAux);
			if (cursorAux.next()) {
				countTmp += cursorAux.getInt(1);
			}
			cursorAux.close();
			cursorAux.close();
			log.println("tmp_plano=" + countTmp);
			
			// cofilial
			gravaPasso("Carregando dados da empresa: " + codEmpresa);
			int nroPlano = 0;
			String sqlFilial = "select nroplano \n" 
					+ "from cofilial \n" 
					+ "where filial = " + codEmpresa;
			Statement stmtFilial = bd.createStatement();
			ResultSet cursorFilial = stmtFilial.executeQuery(sqlFilial);
			if (cursorFilial.next()) {
				nroPlano = cursorFilial.getInt("nroplano");
			}
			cursorFilial.close();
			stmtFilial.close();
			
			carregaPlanos();
			carregaEstornos();
			carregaTmp();
			
			// calcula a quantidade total
			int count = 0;
			String sqlCount = String.format(
					"select count(*) \n" 
							+ "from  molancto \n" 
							+ "where molancto.filial in (%s) \n"
							+ "  and molancto.dtlancto between ? and ? ", filiais);
			PreparedStatement stmtCount = bd.prepareStatement(sqlCount);
			stmtCount.setDate(1, new java.sql.Date(dataIni.getTime()));
			stmtCount.setDate(2, new java.sql.Date(dataFim.getTime()));
			ResultSet cursorCount = stmtCount.executeQuery();
			if (cursorCount.next()) {
				count += cursorCount.getInt(1);
			}
			cursorCount.close();
			stmtCount.close();
			
			sqlCount = String.format(
					"select count(*) \n" 
							+ "from  ctlancto \n" 
							+ "where ctlancto.filial in (%s) \n"
							+ "  and ctlancto.dtlancto between ? and ? ", filiais);
			stmtCount = bd.prepareStatement(sqlCount);
			stmtCount.setDate(1, new java.sql.Date(dataIni.getTime()));
			stmtCount.setDate(2, new java.sql.Date(dataFim.getTime()));
			cursorCount = stmtCount.executeQuery();
			if (cursorCount.next()) {
				count += cursorCount.getInt(1);
			}
			cursorCount.close();
			stmtCount.close();
			
			// lancamentos
			String colunasLancto = "dtlancto, tipolancto, valor, filial, nrolote, nrolancto, id_plano, diario, cgccpf, tppessoa, id_lancto, descrhistor, nrodocto, seqdocto, tpdocto";
			String sql = String.format(
					"select %s, 'M' ArqLancto \n" 
							+ "from  molancto \n" 
							+ "where molancto.filial in (%s) \n"
							+ "  and molancto.dtlancto between ? and ? \n" 
							+ "union \n" 
							+ "select %s, 'A' ArqLancto \n"
							+ "from  ctlancto \n" 
							+ "where ctlancto.filial in (%s) \n"
							+ "  and ctlancto.dtlancto between ? and ? \n"
							+ "order by ArqLancto desc, filial, nrolote, dtlancto, nrolancto",
					colunasLancto, filiais, colunasLancto, filiais);

			PreparedStatement stmt = bd.prepareStatement(sql);
			stmt.setDate(1, new java.sql.Date(dataIni.getTime()));
			stmt.setDate(2, new java.sql.Date(dataFim.getTime()));
			stmt.setDate(3, new java.sql.Date(dataIni.getTime()));
			stmt.setDate(4, new java.sql.Date(dataFim.getTime()));

			ResultSet cursor = stmt.executeQuery();
			
			String loteAnt = "";
			double somaLote = 0;
			int idLancto = 0;
			String diario = "";
			Date t1 = new Date();

			while (cursor.next()) {

				if ((contador % 10000) == 0) {
					mostraProgresso(contador, count, t1);
				}
				contador++;	
				
				idLancto = cursor.getInt("id_lancto");
				arLc = cursor.getString("ArqLancto");
				
				diario = cursor.getString("diario");
				if (diario == null) {
					diario = "GERA";
				}

				// ctplano
				int idPlano = cursor.getInt("id_plano");
				String chave = idPlano + ":" + nroPlano;
				conta = mapaPlano.get(chave);
				if (conta == null) {
					throw new Exception("Nao encontrou cta.lancto " + nroPlano + "/" + idPlano);
				}
				
				int tpPessoa = cursor.getInt("tppessoa");
				String cgcCpf = cursor.getString("cgccpf");
				cCusto = tpPessoa == 8 ? cgcCpf : " ";
				
				data = new Date(cursor.getDate("dtlancto").getTime());
				
				int nroLote = cursor.getInt("nrolote");
				
				String lote = String.format("%09d%s", nroLote, df.format(data));
				
				if (!lote.equals(loteAnt)) {
					
					if (idx200 != -1) {
						atualizaI200(somaLote);
					}
					
					gravaI200(idLancto, diario);
					
					loteAnt = lote;
					somaLote = 0;
				}
				
				String descrhistor = cursor.getString("descrhistor");
				if ((descrhistor == null) || descrhistor.trim().equals("")) {
					descrhistor = "SEM DESCRICAO ";
				}
				descrhistor = SpedUtils.substituiCaracteresInvalidos(descrhistor);

				RegistroTmp tmp = mapaTmp.get(conta.trim());
				if (tmp == null) {
					log.println("conta nao encontrada [" + conta.trim() + "]");
					continue;
				}
				
				double valor = cursor.getDouble("valor");
				
				String tipoLancto = cursor.getString("tipolancto");
				if (tipoLancto.equals("D")) {
					debitos = valor;
					creditos = 0;
					somaLote += debitos;
				} else {
					creditos = valor;
					debitos = 0;
				}
				
				int nrodocto = cursor.getInt("nrodocto");
				int seqdocto = cursor.getInt("seqdocto");
				String tpdocto = cursor.getString("tpdocto");

				String dados = String.format("|%s|%s|%s|%s|%s|%d-%d-%s||%s", 
						"I250",
						mascConta.equals("A") ? tmp.getAnalitica2018() : tmp.getAnalitica2019(),
						cCusto.trim(),
						String.format("%.2f", valor).replace('.', ','),
						tipoLancto,
						nrodocto, seqdocto, 
						tpdocto != null ? tpdocto.trim() : "",
						descrhistor.trim());
				Registro reg = new Registro();
				reg.setBloco(4);
				reg.setNivel(3);
				reg.setOcorr(ocorr++);
				reg.setRegis("I250");
				reg.setIdLc(idLancto);
				reg.setArLc(arLc);
				reg.setDados(dados);				
				registros.add(reg);
//				log.println(registros.size() + " " + reg.getOcorr() + " " + reg.getDados());
				
				Balancete bala = mapa.get(this.toString());
				if (bala == null) {
					bala = new Balancete();
					bala.setData(data);
					bala.setConta(conta);
					bala.setcCusto(cCusto);
					bala.setDebitos(debitos);
					bala.setCreditos(creditos);
				} else {
					bala.setCreditos(bala.getCreditos() + this.getCreditos());
					bala.setDebitos(bala.getDebitos() + this.getDebitos());
				}
				mapa.put(bala.toString(), bala);

			}
			
			if (idx200 != -1) {
				atualizaI200(somaLote);
			}

			cursor.close();
			stmt.close();
			gravaPasso("Registros processados: " + contador);
			
			if (identificacao.equals("G")) {
				gravaPasso("Gerando balancete_arquivo.txt");
				PrintStream saida = new PrintStream(getDiretorio() + (isDebug() ? "balancete_arquivo_debug.txt" :"balancete_arquivo.txt"));
//				int pos = 0;
				for (Registro reg : registros) {
//					log.println(++pos + " = " + reg.getOcorr() + " " + reg.getDados());
					if (!isDebug()) {
						saida.printf("%d;%d;%d;%s;%d;%s;%s%n",
							reg.getBloco(),
							reg.getNivel(),
							reg.getOcorr(),
							reg.getRegis(),
							reg.getIdLc(),
							reg.getArLc(),
							reg.getDados().replace(';', ' '));
					} else {
						saida.printf("%s||\r\n", reg.getDados());
					}
				}
				saida.close();
			}

			bd.close();

			gravaPasso("Gerando balancete.txt");
			PrintStream saida = new PrintStream(getDiretorio() + (isDebug() ? "balancete_debug.txt" : "balancete.txt"));
			for (String chave : mapa.keySet()) {
				Balancete bala = mapa.get(chave);
				saida.printf("%s;%s;%s;%s;%s%n", 
						dfSaida.format(bala.getData()), 
						bala.getConta(),
						bala.getcCusto(),
						String.format("%.2f", bala.getDebitos()).replace('.', ','),
						String.format("%.2f", bala.getCreditos()).replace('.', ','));
			}
			saida.close();
			
			Date t2 = new Date();
			gravaPasso("tempo(min)=" + ((t2.getTime() - t1.getTime()) / 60000));
			gravaPasso("ok");
			log.println("tempo(seg)=" + ((t2.getTime() - t1.getTime()) / 1000));
			log.close();

		} catch (Exception e) {
			e.printStackTrace();
			PrintStream result = new PrintStream(getDiretorio() + (isDebug() ? "balancete_debug.out" : "balancete.out"));
			result.println("erro: " + e.getMessage());
			result.close();
			throw e;

		} finally {
			if (bd != null) {
				try {
					bd.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private void carregaEstornos() throws SQLException {
		
		String sql = "select id_lancto, id_lancto_est from ctlctest";
		Statement stmt = bd.createStatement();
		ResultSet cursor = stmt.executeQuery(sql);
		while (cursor.next()) {
			int idLancto = cursor.getInt("id_lancto");
			mapaEstorno1.put(idLancto, true);
			int idLanctoEst = cursor.getInt("id_lancto_est");
			mapaEstorno2.put(idLanctoEst, true);			
		}
		cursor.close();
		stmt.close();
		
	}

	private void carregaPlanos() throws SQLException {
		
		String sql = "select id_plano, nroplano, conta from ctplano";
		Statement stmt = bd.createStatement();
		ResultSet cursor = stmt.executeQuery(sql);
		while (cursor.next()) {
			int idPlano = cursor.getInt("id_plano");
			int nroplano = cursor.getInt("nroplano");
			String chave = idPlano + ":" + nroplano;
			String conta = cursor.getString("conta");
			if (conta != null) {
				mapaPlano.put(chave, conta.trim());
			}
		}
		cursor.close();
		stmt.close();
		
	}

	private void carregaTmp() throws SQLException {
	
		String sql = "select conta, original, analitica_2018, analitica_2019 \n"
				+ "from  tmp_plano \n"
				+ "order by original desc";
		
		Statement stmt = bd.createStatement();
		ResultSet cursor = stmt.executeQuery(sql);
		while (cursor.next()) {
			
			String conta = cursor.getString("conta");
			
			RegistroTmp tmp = new RegistroTmp();
			tmp.setAnalitica2018(cursor.getString("analitica_2018").trim());
			tmp.setAnalitica2019(cursor.getString("analitica_2019").trim());
			
			mapaTmp.put(conta.trim(), tmp);
			
		}
		cursor.close();
		stmt.close();
		
	}
	
	private void gravaI200(int idLancto, String diario) throws SQLException {
		
		String indLcto = diario.equals("BALA") ? "E" : "N";
		
		// ctlctest
		if ((mapaEstorno1.get(idLancto) != null) || (mapaEstorno2.get(idLancto) != null)) {
			indLcto = "N";
		}
		
		String dados = String.format("|%s|%d|%s|%s|%s%s", 
					"I200",
					idLancto,
					dfSaida.format(data),
					"SOMALOTE",
					indLcto,
					finalizador);
		
		Registro reg = new Registro();
		reg.setBloco(4);
		reg.setNivel(3);
		reg.setOcorr(ocorr++);
		reg.setRegis("I200");
		reg.setIdLc(0);
		reg.setArLc(arLc);
		reg.setDados(dados);
		
		registros.add(reg);
//		log.println(registros.size() + " " + reg.getOcorr() + " " + reg.getDados());
		idx200 = registros.size() - 1;
		
	}
	
	private void atualizaI200(double somaLote) throws SQLException {
		
		Registro reg = registros.get(idx200);
		if (reg == null) {
			return;
		}
		
		String dados = reg.getDados().replace("SOMALOTE", String.format("%.2f", somaLote).replace('.', ','));
		reg.setDados(dados);
		
	}

	@Override
	public String toString() {
		return dfSaida.format(data) + ":" + conta + ":" + cCusto;
	}

	public Date getData() {
		return data;
	}

	public void setData(Date data) {
		this.data = data;
	}

	public String getConta() {
		return conta;
	}

	public void setConta(String conta) {
		this.conta = conta;
	}

	public String getcCusto() {
		return cCusto;
	}

	public void setcCusto(String cCusto) {
		this.cCusto = cCusto;
	}

	public double getDebitos() {
		return debitos;
	}

	public void setDebitos(double debitos) {
		this.debitos = debitos;
	}

	public double getCreditos() {
		return creditos;
	}

	public void setCreditos(double creditos) {
		this.creditos = creditos;
	}

}



