package br.com.linx.sisdia.fiscal.sped;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

public class CmdSped {
	
	private static String diretorio;
	private static String comando;
	private static boolean debug;
	
	public CmdSped() {
		debug = System.getenv("SPED_DBG") != null;
	}

	public static void mostraProgresso(int contador, int count, Date t1) throws FileNotFoundException {
		
		String msgRestante = "";
		gravaPasso("Registros processados: " + contador + " de " + count + msgRestante);
	}
	
	public static void gravaPasso(String msg) throws FileNotFoundException {
		
		Date data = new Date();
		DateFormat df = new SimpleDateFormat("HH:mm:ss");
		System.out.println(df.format(data) + " " + msg);
		PrintStream result = new PrintStream(diretorio + (debug ? (comando + "_debug.out") : (comando + ".out")));
		result.println(msg);
		result.close();
		
	}
	
	public static String carregaDiretorio(Connection bd, int codEmpresa) throws SQLException {
		
		diretorio = "./";
		String sql = "select diretorio \n" 
				+ "from cadireto \n" 
				+ "where nomeprog='SPED1000' and filial = " + codEmpresa;
		Statement stmt = bd.createStatement();
		ResultSet cursor = stmt.executeQuery(sql);
		if (cursor.next()) {
			diretorio = cursor.getString("diretorio").trim();
		}
		cursor.close();
		stmt.close();
		
		return diretorio;
		
	}
	
	public static Connection conectaBanco(String url) throws SQLException, ClassNotFoundException {

		String driver = "com.informix.jdbc.IfxDriver";
		Class.forName(driver);
		Connection bd = DriverManager.getConnection(url);
		bd.createStatement().execute("set isolation to dirty read");
		return bd;
		
	}
	
	public String getDiretorio() {
		return diretorio;
	}

	public void setComando(String comando) {
		CmdSped.comando = comando;
	}

	public boolean isDebug() {
		return debug;
	}

}
