package br.com.linx.sisdia.jd;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;

import br.com.linx.sisdia.Cmd;

public class EncontraArquivo extends Cmd {

	private Connection bd;

	public static void main(String[] args) throws Exception {

		if (args.length != 5) {
			System.out.println("Uso: EncontraArquivo <url> <nomePrograma> <inicialPrograma> <codEmpresa> <arqSaida> <encontraArq>");
			return;
		}		

		// argumentos
		String url = args[0];
		String nomePrograma = args[1];
		int codEmpresa = Integer.parseInt(args[2]);
		String arqSaida = args[3];
		String encontraArq = args[4];

		EncontraArquivo jd = new EncontraArquivo();
		jd.setComando("encontra_arquivo");

		jd.processa(url, nomePrograma, codEmpresa, arqSaida, encontraArq);

	}

	private void processa(String url, String nomePrograma, int codEmpresa, String arqSaida, String encontraArq) throws Exception {
		try {
			System.out.println(System.getProperty("user.dir"));
			bd = conectaBanco(url);
			carregaDiretorio(bd, codEmpresa, nomePrograma);

			SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");

			File diretorio = new File("processado");
			if (!diretorio.isDirectory() || !diretorio.exists()) {
				diretorio.mkdir();
			}
			diretorio.setReadable(true);
			diretorio.setWritable(true);

			String sql = String.format("select * from jdcornum \n" + 
					" where jdcornum.matriz = " + codEmpresa + " \n"
					+ "and jdcornum.tipo    = 'T' \n"
					+ "and jdcornum.arquivo = ? ");
			PreparedStatement stmt = bd.prepareStatement(sql);

			Date ldatault = null;
			String garqtra = null;
			String nomeArquivo = null;

			PrintStream saida = new PrintStream(getDiretorio() + arqSaida, "ISO-8859-1");

			diretorio = new File(getDiretorio());
			String[] listaArquivos = diretorio.list();
			for (int i=0;i<listaArquivos.length; i++) {
				nomeArquivo = listaArquivos[i];

				if (nomeArquivo.length() < 15)
					continue;

				try 
				{
					FileWriter fw = new FileWriter(nomeArquivo);
					fw.close();
				}
				catch (IOException e)
				{
					continue;
				}				

				stmt.setString(1, nomeArquivo);
				ResultSet cursor = stmt.executeQuery();
				if (cursor.next()) {
					Files.move(Paths.get(getDiretorio() + nomeArquivo),  
							Paths.get("processado/" + nomeArquivo)); 					
					continue;
				}
				
				cursor.close();
				
				if (nomeArquivo.substring(0,15).equals("JD2DLR_DPMXFER_") || 
						nomeArquivo.substring(0,15).equals("jd2dlr_dpmxfer_")) {
					if (encontraArq.equalsIgnoreCase("S")) {
						Date ldata = format.parse(nomeArquivo.substring(15,19) + "-" 
								+ nomeArquivo.substring(19,21) + "-" 
								+ nomeArquivo.substring(21,23) + " " + 
								nomeArquivo.substring(24,26) + ":" + 
								nomeArquivo.substring(26,28) + ":" + 
								nomeArquivo.substring(28,30));
						if ((ldatault == null) || (ldata.compareTo(ldatault) > 0)) {
							ldatault = ldata;
							garqtra  = nomeArquivo;
						}
					} else {
						saida.printf("%s\r\n", nomeArquivo);
					}
				}
			}

			if (encontraArq.equalsIgnoreCase("S")) {
				saida.printf("%s\r\n", garqtra);
			}
			saida.close();
			
			stmt.close();
		} catch (Exception e) {
			e.printStackTrace();
			PrintStream result = new PrintStream(
					getDiretorio() + (isDebug() ? "encontra_arquivo_debug.out" : "encontra_arquivo.out"));
			result.println("erro: " + e.getMessage());
			e.printStackTrace(result);
			result.close();
			throw e;
		} finally {
			if (bd != null) {
				try {
					bd.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}
	}


}
