package br.com.linx.sisdia.tabelas;

import br.com.linx.sisdia.Coluna;
import br.com.linx.sisdia.tipos.FglDateTimeYS;
import br.com.linx.sisdia.tipos.FglDate;

public class TabAgenda {
@Coluna(nome="agenda.codigo", tipo="int")
private int codigo;
private boolean codigoNull;
@Coluna(nome="agenda.processo", tipo="String")
private String processo;
@Coluna(nome="agenda.tipo", tipo="String")
private String tipo;
@Coluna(nome="agenda.hora_inicial", tipo="FglDateTimeYS")
private FglDateTimeYS horaInicial;
@Coluna(nome="agenda.quantidade_execucoes", tipo="int")
private int quantidadeExecucoes;
private boolean quantidadeExecucoesNull;
@Coluna(nome="agenda.intervalo_minutos", tipo="int")
private int intervaloMinutos;
private boolean intervaloMinutosNull;
@Coluna(nome="agenda.data_programacao", tipo="FglDate")
private FglDate dataProgramacao;
@Coluna(nome="agenda.exec_dom", tipo="String")
private String execDom;
@Coluna(nome="agenda.exec_seg", tipo="String")
private String execSeg;
@Coluna(nome="agenda.exec_ter", tipo="String")
private String execTer;
@Coluna(nome="agenda.exec_qua", tipo="String")
private String execQua;
@Coluna(nome="agenda.exec_qui", tipo="String")
private String execQui;
@Coluna(nome="agenda.exec_sex", tipo="String")
private String execSex;
@Coluna(nome="agenda.exec_sab", tipo="String")
private String execSab;

public TabAgenda() {
initialize();
}

public void initialize() {
setCodigo(null);
setProcesso(null);
setTipo(null);
setHoraInicial(null);
setQuantidadeExecucoes(null);
setIntervaloMinutos(null);
setDataProgramacao(null);
setExecDom(null);
setExecSeg(null);
setExecTer(null);
setExecQua(null);
setExecQui(null);
setExecSex(null);
setExecSab(null);
}

public TabAgenda(int codigo, String processo, String tipo, FglDateTimeYS horaInicial, int quantidadeExecucoes, int intervaloMinutos, FglDate dataProgramacao, String execDom, String execSeg, String execTer, String execQua, String execQui, String execSex, String execSab) {
this.codigo = codigo;
this.processo = processo;
this.tipo = tipo;
this.horaInicial = horaInicial;
this.quantidadeExecucoes = quantidadeExecucoes;
this.intervaloMinutos = intervaloMinutos;
this.dataProgramacao = dataProgramacao;
this.execDom = execDom;
this.execSeg = execSeg;
this.execTer = execTer;
this.execQua = execQua;
this.execQui = execQui;
this.execSex = execSex;
this.execSab = execSab;
}

public int getCodigo() {
return codigo;
}

public boolean isCodigoNull() {
return codigoNull;
}

public void setCodigo(Integer codigo) {
if (codigo == null) {
codigoNull = true;
this.codigo = 0;
} else { 
codigoNull = false;
this.codigo = codigo;
}
}

public String getProcesso() {
return processo;
}

public void setProcesso(String processo) {
this.processo = processo;
}

public String getTipo() {
return tipo;
}

public void setTipo(String tipo) {
this.tipo = tipo;
}

public FglDateTimeYS getHoraInicial() {
return horaInicial;
}

public void setHoraInicial(FglDateTimeYS horaInicial) {
this.horaInicial = horaInicial;
}

public int getQuantidadeExecucoes() {
return quantidadeExecucoes;
}

public boolean isQuantidadeExecucoesNull() {
return quantidadeExecucoesNull;
}

public void setQuantidadeExecucoes(Integer quantidadeExecucoes) {
if (quantidadeExecucoes == null) {
quantidadeExecucoesNull = true;
this.quantidadeExecucoes = 0;
} else { 
quantidadeExecucoesNull = false;
this.quantidadeExecucoes = quantidadeExecucoes;
}
}

public int getIntervaloMinutos() {
return intervaloMinutos;
}

public boolean isIntervaloMinutosNull() {
return intervaloMinutosNull;
}

public void setIntervaloMinutos(Integer intervaloMinutos) {
if (intervaloMinutos == null) {
intervaloMinutosNull = true;
this.intervaloMinutos = 0;
} else { 
intervaloMinutosNull = false;
this.intervaloMinutos = intervaloMinutos;
}
}

public FglDate getDataProgramacao() {
return dataProgramacao;
}

public void setDataProgramacao(FglDate dataProgramacao) {
this.dataProgramacao = dataProgramacao;
}

public String getExecDom() {
return execDom;
}

public void setExecDom(String execDom) {
this.execDom = execDom;
}

public String getExecSeg() {
return execSeg;
}

public void setExecSeg(String execSeg) {
this.execSeg = execSeg;
}

public String getExecTer() {
return execTer;
}

public void setExecTer(String execTer) {
this.execTer = execTer;
}

public String getExecQua() {
return execQua;
}

public void setExecQua(String execQua) {
this.execQua = execQua;
}

public String getExecQui() {
return execQui;
}

public void setExecQui(String execQui) {
this.execQui = execQui;
}

public String getExecSex() {
return execSex;
}

public void setExecSex(String execSex) {
this.execSex = execSex;
}

public String getExecSab() {
return execSab;
}

public void setExecSab(String execSab) {
this.execSab = execSab;
}

}

