package br.com.linx.sisdia.tabelas;

import br.com.linx.sisdia.Coluna;
import br.com.linx.sisdia.tipos.FglDateTimeYS;
import br.com.linx.sisdia.tipos.FglDouble;

public class TabChrSalesEstoque {
@Coluna(nome="chr_sales_estoque.cod_concessionaria", tipo="String")
private String codConcessionaria;
@Coluna(nome="chr_sales_estoque.chassi", tipo="String")
private String chassi;
@Coluna(nome="chr_sales_estoque.dta_inclusao", tipo="FglDateTimeYS")
private FglDateTimeYS dtaInclusao;
@Coluna(nome="chr_sales_estoque.status_envio", tipo="String")
private String statusEnvio;
@Coluna(nome="chr_sales_estoque.marca", tipo="String")
private String marca;
@Coluna(nome="chr_sales_estoque.modelo", tipo="String")
private String modelo;
@Coluna(nome="chr_sales_estoque.descricao", tipo="String")
private String descricao;
@Coluna(nome="chr_sales_estoque.opcionais", tipo="String")
private String opcionais;
@Coluna(nome="chr_sales_estoque.valor", tipo="double")
private double valor;
private boolean valorNull;
@Coluna(nome="chr_sales_estoque.tipo_estoque", tipo="String")
private String tipoEstoque;
@Coluna(nome="chr_sales_estoque.ano_fabricacao", tipo="double")
private double anoFabricacao;
private boolean anoFabricacaoNull;
@Coluna(nome="chr_sales_estoque.ano_modelo", tipo="double")
private double anoModelo;
private boolean anoModeloNull;
@Coluna(nome="chr_sales_estoque.cor_interna", tipo="String")
private String corInterna;
@Coluna(nome="chr_sales_estoque.cor_externa", tipo="String")
private String corExterna;
@Coluna(nome="chr_sales_estoque.combustivel", tipo="String")
private String combustivel;
@Coluna(nome="chr_sales_estoque.mvs", tipo="String")
private String mvs;
@Coluna(nome="chr_sales_estoque.procedencia", tipo="String")
private String procedencia;
@Coluna(nome="chr_sales_estoque.placa", tipo="String")
private String placa;
@Coluna(nome="chr_sales_estoque.acessorios", tipo="String")
private String acessorios;
@Coluna(nome="chr_sales_estoque.situacao", tipo="String")
private String situacao;
@Coluna(nome="chr_sales_estoque.status", tipo="String")
private String status;
@Coluna(nome="chr_sales_estoque.dta_ent_estoque", tipo="FglDateTimeYS")
private FglDateTimeYS dtaEntEstoque;
@Coluna(nome="chr_sales_estoque.dta_venda", tipo="FglDateTimeYS")
private FglDateTimeYS dtaVenda;
@Coluna(nome="chr_sales_estoque.cod_retorno", tipo="String")
private String codRetorno;
@Coluna(nome="chr_sales_estoque.des_retorno", tipo="String")
private String desRetorno;

public TabChrSalesEstoque() {
initialize();
}

public void initialize() {
setCodConcessionaria(null);
setChassi(null);
setDtaInclusao(null);
setStatusEnvio(null);
setMarca(null);
setModelo(null);
setDescricao(null);
setOpcionais(null);
setValor(null);
setTipoEstoque(null);
setAnoFabricacao(null);
setAnoModelo(null);
setCorInterna(null);
setCorExterna(null);
setCombustivel(null);
setMvs(null);
setProcedencia(null);
setPlaca(null);
setAcessorios(null);
setSituacao(null);
setStatus(null);
setDtaEntEstoque(null);
setDtaVenda(null);
setCodRetorno(null);
setDesRetorno(null);
}

public TabChrSalesEstoque(String codConcessionaria, String chassi, FglDateTimeYS dtaInclusao, String statusEnvio, String marca, String modelo, String descricao, String opcionais, double valor, String tipoEstoque, double anoFabricacao, double anoModelo, String corInterna, String corExterna, String combustivel, String mvs, String procedencia, String placa, String acessorios, String situacao, String status, FglDateTimeYS dtaEntEstoque, FglDateTimeYS dtaVenda, String codRetorno, String desRetorno) {
this.codConcessionaria = codConcessionaria;
this.chassi = chassi;
this.dtaInclusao = dtaInclusao;
this.statusEnvio = statusEnvio;
this.marca = marca;
this.modelo = modelo;
this.descricao = descricao;
this.opcionais = opcionais;
this.valor = valor;
this.tipoEstoque = tipoEstoque;
this.anoFabricacao = anoFabricacao;
this.anoModelo = anoModelo;
this.corInterna = corInterna;
this.corExterna = corExterna;
this.combustivel = combustivel;
this.mvs = mvs;
this.procedencia = procedencia;
this.placa = placa;
this.acessorios = acessorios;
this.situacao = situacao;
this.status = status;
this.dtaEntEstoque = dtaEntEstoque;
this.dtaVenda = dtaVenda;
this.codRetorno = codRetorno;
this.desRetorno = desRetorno;
}

public String getCodConcessionaria() {
return codConcessionaria;
}

public void setCodConcessionaria(String codConcessionaria) {
this.codConcessionaria = codConcessionaria;
}

public String getChassi() {
return chassi;
}

public void setChassi(String chassi) {
this.chassi = chassi;
}

public FglDateTimeYS getDtaInclusao() {
return dtaInclusao;
}

public void setDtaInclusao(FglDateTimeYS dtaInclusao) {
this.dtaInclusao = dtaInclusao;
}

public String getStatusEnvio() {
return statusEnvio;
}

public void setStatusEnvio(String statusEnvio) {
this.statusEnvio = statusEnvio;
}

public String getMarca() {
return marca;
}

public void setMarca(String marca) {
this.marca = marca;
}

public String getModelo() {
return modelo;
}

public void setModelo(String modelo) {
this.modelo = modelo;
}

public String getDescricao() {
return descricao;
}

public void setDescricao(String descricao) {
this.descricao = descricao;
}

public String getOpcionais() {
return opcionais;
}

public void setOpcionais(String opcionais) {
this.opcionais = opcionais;
}

public double getValor() {
return valor;
}

public boolean isValorNull() {
return valorNull;
}

public void setValor(int valor) {
setValor(new Double(valor));
}

public void setValor(long valor) {
setValor(new Double(valor));
}

public void setValor(Double valor) {
if (valor == null) {
valorNull = true;
this.valor = 0.;
} else { 
valorNull = false;
this.valor = FglDouble.round(valor, 2);
}
}

public String getTipoEstoque() {
return tipoEstoque;
}

public void setTipoEstoque(String tipoEstoque) {
this.tipoEstoque = tipoEstoque;
}

public double getAnoFabricacao() {
return anoFabricacao;
}

public boolean isAnoFabricacaoNull() {
return anoFabricacaoNull;
}

public void setAnoFabricacao(int anoFabricacao) {
setAnoFabricacao(new Double(anoFabricacao));
}

public void setAnoFabricacao(long anoFabricacao) {
setAnoFabricacao(new Double(anoFabricacao));
}

public void setAnoFabricacao(Double anoFabricacao) {
if (anoFabricacao == null) {
anoFabricacaoNull = true;
this.anoFabricacao = 0.;
} else { 
anoFabricacaoNull = false;
this.anoFabricacao = anoFabricacao;
}
}

public double getAnoModelo() {
return anoModelo;
}

public boolean isAnoModeloNull() {
return anoModeloNull;
}

public void setAnoModelo(int anoModelo) {
setAnoModelo(new Double(anoModelo));
}

public void setAnoModelo(long anoModelo) {
setAnoModelo(new Double(anoModelo));
}

public void setAnoModelo(Double anoModelo) {
if (anoModelo == null) {
anoModeloNull = true;
this.anoModelo = 0.;
} else { 
anoModeloNull = false;
this.anoModelo = anoModelo;
}
}

public String getCorInterna() {
return corInterna;
}

public void setCorInterna(String corInterna) {
this.corInterna = corInterna;
}

public String getCorExterna() {
return corExterna;
}

public void setCorExterna(String corExterna) {
this.corExterna = corExterna;
}

public String getCombustivel() {
return combustivel;
}

public void setCombustivel(String combustivel) {
this.combustivel = combustivel;
}

public String getMvs() {
return mvs;
}

public void setMvs(String mvs) {
this.mvs = mvs;
}

public String getProcedencia() {
return procedencia;
}

public void setProcedencia(String procedencia) {
this.procedencia = procedencia;
}

public String getPlaca() {
return placa;
}

public void setPlaca(String placa) {
this.placa = placa;
}

public String getAcessorios() {
return acessorios;
}

public void setAcessorios(String acessorios) {
this.acessorios = acessorios;
}

public String getSituacao() {
return situacao;
}

public void setSituacao(String situacao) {
this.situacao = situacao;
}

public String getStatus() {
return status;
}

public void setStatus(String status) {
this.status = status;
}

public FglDateTimeYS getDtaEntEstoque() {
return dtaEntEstoque;
}

public void setDtaEntEstoque(FglDateTimeYS dtaEntEstoque) {
this.dtaEntEstoque = dtaEntEstoque;
}

public FglDateTimeYS getDtaVenda() {
return dtaVenda;
}

public void setDtaVenda(FglDateTimeYS dtaVenda) {
this.dtaVenda = dtaVenda;
}

public String getCodRetorno() {
return codRetorno;
}

public void setCodRetorno(String codRetorno) {
this.codRetorno = codRetorno;
}

public String getDesRetorno() {
return desRetorno;
}

public void setDesRetorno(String desRetorno) {
this.desRetorno = desRetorno;
}

}

