package br.com.linx.sisdia.tabelas;

import br.com.linx.sisdia.Coluna;
import br.com.linx.sisdia.tipos.FglDateTimeYM;
import br.com.linx.sisdia.tipos.FglDouble;

public class TabCsmetase {
@Coluna(nome="csmetase.filial", tipo="int")
private int filial;
private boolean filialNull;
@Coluna(nome="csmetase.usogenerico", tipo="String")
private String usogenerico;
@Coluna(nome="csmetase.anomes", tipo="FglDateTimeYM")
private FglDateTimeYM anomes;
@Coluna(nome="csmetase.metaliquida", tipo="double")
private double metaliquida;
private boolean metaliquidaNull;
@Coluna(nome="csmetase.metabruta", tipo="double")
private double metabruta;
private boolean metabrutaNull;

public TabCsmetase() {
initialize();
}

public void initialize() {
setFilial(null);
setUsogenerico(null);
setAnomes(null);
setMetaliquida(null);
setMetabruta(null);
}

public TabCsmetase(int filial, String usogenerico, FglDateTimeYM anomes, double metaliquida, double metabruta) {
this.filial = filial;
this.usogenerico = usogenerico;
this.anomes = anomes;
this.metaliquida = metaliquida;
this.metabruta = metabruta;
}

public int getFilial() {
return filial;
}

public boolean isFilialNull() {
return filialNull;
}

public void setFilial(Integer filial) {
if (filial == null) {
filialNull = true;
this.filial = 0;
} else { 
filialNull = false;
this.filial = filial;
}
}

public String getUsogenerico() {
return usogenerico;
}

public void setUsogenerico(String usogenerico) {
this.usogenerico = usogenerico;
}

public FglDateTimeYM getAnomes() {
return anomes;
}

public void setAnomes(FglDateTimeYM anomes) {
this.anomes = anomes;
}

public double getMetaliquida() {
return metaliquida;
}

public boolean isMetaliquidaNull() {
return metaliquidaNull;
}

public void setMetaliquida(int metaliquida) {
setMetaliquida(new Double(metaliquida));
}

public void setMetaliquida(long metaliquida) {
setMetaliquida(new Double(metaliquida));
}

public void setMetaliquida(Double metaliquida) {
if (metaliquida == null) {
metaliquidaNull = true;
this.metaliquida = 0.;
} else { 
metaliquidaNull = false;
this.metaliquida = FglDouble.round(metaliquida, 2);
}
}

public double getMetabruta() {
return metabruta;
}

public boolean isMetabrutaNull() {
return metabrutaNull;
}

public void setMetabruta(int metabruta) {
setMetabruta(new Double(metabruta));
}

public void setMetabruta(long metabruta) {
setMetabruta(new Double(metabruta));
}

public void setMetabruta(Double metabruta) {
if (metabruta == null) {
metabrutaNull = true;
this.metabruta = 0.;
} else { 
metabrutaNull = false;
this.metabruta = FglDouble.round(metabruta, 2);
}
}

}

