package br.com.linx.sisdia.tabelas;

import br.com.linx.sisdia.Coluna;
import br.com.linx.sisdia.tipos.FglDateTimeYM;
import br.com.linx.sisdia.tipos.FglDouble;

public class TabCxpreven {
@Coluna(nome="cxpreven.modelo", tipo="String")
private String modelo;
@Coluna(nome="cxpreven.anomes", tipo="FglDateTimeYM")
private FglDateTimeYM anomes;
@Coluna(nome="cxpreven.prevvenda", tipo="int")
private int prevvenda;
private boolean prevvendaNull;
@Coluna(nome="cxpreven.perdesven", tipo="double")
private double perdesven;
private boolean perdesvenNull;
@Coluna(nome="cxpreven.perdesger", tipo="double")
private double perdesger;
private boolean perdesgerNull;

public TabCxpreven() {
initialize();
}

public void initialize() {
setModelo(null);
setAnomes(null);
setPrevvenda(null);
setPerdesven(null);
setPerdesger(null);
}

public TabCxpreven(String modelo, FglDateTimeYM anomes, int prevvenda, double perdesven, double perdesger) {
this.modelo = modelo;
this.anomes = anomes;
this.prevvenda = prevvenda;
this.perdesven = perdesven;
this.perdesger = perdesger;
}

public String getModelo() {
return modelo;
}

public void setModelo(String modelo) {
this.modelo = modelo;
}

public FglDateTimeYM getAnomes() {
return anomes;
}

public void setAnomes(FglDateTimeYM anomes) {
this.anomes = anomes;
}

public int getPrevvenda() {
return prevvenda;
}

public boolean isPrevvendaNull() {
return prevvendaNull;
}

public void setPrevvenda(Integer prevvenda) {
if (prevvenda == null) {
prevvendaNull = true;
this.prevvenda = 0;
} else { 
prevvendaNull = false;
this.prevvenda = prevvenda;
}
}

public double getPerdesven() {
return perdesven;
}

public boolean isPerdesvenNull() {
return perdesvenNull;
}

public void setPerdesven(int perdesven) {
setPerdesven(new Double(perdesven));
}

public void setPerdesven(long perdesven) {
setPerdesven(new Double(perdesven));
}

public void setPerdesven(Double perdesven) {
if (perdesven == null) {
perdesvenNull = true;
this.perdesven = 0.;
} else { 
perdesvenNull = false;
this.perdesven = FglDouble.round(perdesven, 2);
}
}

public double getPerdesger() {
return perdesger;
}

public boolean isPerdesgerNull() {
return perdesgerNull;
}

public void setPerdesger(int perdesger) {
setPerdesger(new Double(perdesger));
}

public void setPerdesger(long perdesger) {
setPerdesger(new Double(perdesger));
}

public void setPerdesger(Double perdesger) {
if (perdesger == null) {
perdesgerNull = true;
this.perdesger = 0.;
} else { 
perdesgerNull = false;
this.perdesger = FglDouble.round(perdesger, 2);
}
}

}

