package br.com.linx.sisdia.tabelas;

import br.com.linx.sisdia.Coluna;
import br.com.linx.sisdia.tipos.FglDateTimeYS;

public class TabItcCadcliente {
@Coluna(nome="itc_cadcliente.cpf_cnpj", tipo="double")
private double cpfCnpj;
private boolean cpfCnpjNull;
@Coluna(nome="itc_cadcliente.tipo_pessoa", tipo="String")
private String tipoPessoa;
@Coluna(nome="itc_cadcliente.nome", tipo="String")
private String nome;
@Coluna(nome="itc_cadcliente.tipovia", tipo="String")
private String tipovia;
@Coluna(nome="itc_cadcliente.logradouro", tipo="String")
private String logradouro;
@Coluna(nome="itc_cadcliente.numero", tipo="String")
private String numero;
@Coluna(nome="itc_cadcliente.complemento", tipo="String")
private String complemento;
@Coluna(nome="itc_cadcliente.bairro", tipo="String")
private String bairro;
@Coluna(nome="itc_cadcliente.cep", tipo="String")
private String cep;
@Coluna(nome="itc_cadcliente.municipio", tipo="String")
private String municipio;
@Coluna(nome="itc_cadcliente.uf", tipo="String")
private String uf;
@Coluna(nome="itc_cadcliente.ddd_telefone", tipo="String")
private String dddTelefone;
@Coluna(nome="itc_cadcliente.telefone", tipo="String")
private String telefone;
@Coluna(nome="itc_cadcliente.ramal", tipo="String")
private String ramal;
@Coluna(nome="itc_cadcliente.ddd_celular", tipo="String")
private String dddCelular;
@Coluna(nome="itc_cadcliente.celular", tipo="String")
private String celular;
@Coluna(nome="itc_cadcliente.e_mail", tipo="String")
private String eMail;
@Coluna(nome="itc_cadcliente.identidade", tipo="String")
private String identidade;
@Coluna(nome="itc_cadcliente.sexo", tipo="String")
private String sexo;
@Coluna(nome="itc_cadcliente.data_nascimento", tipo="FglDateTimeYS")
private FglDateTimeYS dataNascimento;
@Coluna(nome="itc_cadcliente.inscricao_estadual", tipo="String")
private String inscricaoEstadual;
@Coluna(nome="itc_cadcliente.data_inicio_atividade", tipo="FglDateTimeYS")
private FglDateTimeYS dataInicioAtividade;
@Coluna(nome="itc_cadcliente.data_cadastro", tipo="FglDateTimeYS")
private FglDateTimeYS dataCadastro;
@Coluna(nome="itc_cadcliente.status_cadastro", tipo="String")
private String statusCadastro;
@Coluna(nome="itc_cadcliente.desc_cadastro", tipo="String")
private String descCadastro;
@Coluna(nome="itc_cadcliente.ssp", tipo="String")
private String ssp;

public TabItcCadcliente() {
initialize();
}

public void initialize() {
setCpfCnpj(null);
setTipoPessoa(null);
setNome(null);
setTipovia(null);
setLogradouro(null);
setNumero(null);
setComplemento(null);
setBairro(null);
setCep(null);
setMunicipio(null);
setUf(null);
setDddTelefone(null);
setTelefone(null);
setRamal(null);
setDddCelular(null);
setCelular(null);
setEMail(null);
setIdentidade(null);
setSexo(null);
setDataNascimento(null);
setInscricaoEstadual(null);
setDataInicioAtividade(null);
setDataCadastro(null);
setStatusCadastro(null);
setDescCadastro(null);
setSsp(null);
}

public TabItcCadcliente(double cpfCnpj, String tipoPessoa, String nome, String tipovia, String logradouro, String numero, String complemento, String bairro, String cep, String municipio, String uf, String dddTelefone, String telefone, String ramal, String dddCelular, String celular, String eMail, String identidade, String sexo, FglDateTimeYS dataNascimento, String inscricaoEstadual, FglDateTimeYS dataInicioAtividade, FglDateTimeYS dataCadastro, String statusCadastro, String descCadastro, String ssp) {
this.cpfCnpj = cpfCnpj;
this.tipoPessoa = tipoPessoa;
this.nome = nome;
this.tipovia = tipovia;
this.logradouro = logradouro;
this.numero = numero;
this.complemento = complemento;
this.bairro = bairro;
this.cep = cep;
this.municipio = municipio;
this.uf = uf;
this.dddTelefone = dddTelefone;
this.telefone = telefone;
this.ramal = ramal;
this.dddCelular = dddCelular;
this.celular = celular;
this.eMail = eMail;
this.identidade = identidade;
this.sexo = sexo;
this.dataNascimento = dataNascimento;
this.inscricaoEstadual = inscricaoEstadual;
this.dataInicioAtividade = dataInicioAtividade;
this.dataCadastro = dataCadastro;
this.statusCadastro = statusCadastro;
this.descCadastro = descCadastro;
this.ssp = ssp;
}

public double getCpfCnpj() {
return cpfCnpj;
}

public boolean isCpfCnpjNull() {
return cpfCnpjNull;
}

public void setCpfCnpj(int cpfCnpj) {
setCpfCnpj(new Double(cpfCnpj));
}

public void setCpfCnpj(long cpfCnpj) {
setCpfCnpj(new Double(cpfCnpj));
}

public void setCpfCnpj(Double cpfCnpj) {
if (cpfCnpj == null) {
cpfCnpjNull = true;
this.cpfCnpj = 0.;
} else { 
cpfCnpjNull = false;
this.cpfCnpj = cpfCnpj;
}
}

public String getTipoPessoa() {
return tipoPessoa;
}

public void setTipoPessoa(String tipoPessoa) {
this.tipoPessoa = tipoPessoa;
}

public String getNome() {
return nome;
}

public void setNome(String nome) {
this.nome = nome;
}

public String getTipovia() {
return tipovia;
}

public void setTipovia(String tipovia) {
this.tipovia = tipovia;
}

public String getLogradouro() {
return logradouro;
}

public void setLogradouro(String logradouro) {
this.logradouro = logradouro;
}

public String getNumero() {
return numero;
}

public void setNumero(String numero) {
this.numero = numero;
}

public String getComplemento() {
return complemento;
}

public void setComplemento(String complemento) {
this.complemento = complemento;
}

public String getBairro() {
return bairro;
}

public void setBairro(String bairro) {
this.bairro = bairro;
}

public String getCep() {
return cep;
}

public void setCep(String cep) {
this.cep = cep;
}

public String getMunicipio() {
return municipio;
}

public void setMunicipio(String municipio) {
this.municipio = municipio;
}

public String getUf() {
return uf;
}

public void setUf(String uf) {
this.uf = uf;
}

public String getDddTelefone() {
return dddTelefone;
}

public void setDddTelefone(String dddTelefone) {
this.dddTelefone = dddTelefone;
}

public String getTelefone() {
return telefone;
}

public void setTelefone(String telefone) {
this.telefone = telefone;
}

public String getRamal() {
return ramal;
}

public void setRamal(String ramal) {
this.ramal = ramal;
}

public String getDddCelular() {
return dddCelular;
}

public void setDddCelular(String dddCelular) {
this.dddCelular = dddCelular;
}

public String getCelular() {
return celular;
}

public void setCelular(String celular) {
this.celular = celular;
}

public String getEMail() {
return eMail;
}

public void setEMail(String eMail) {
this.eMail = eMail;
}

public String getIdentidade() {
return identidade;
}

public void setIdentidade(String identidade) {
this.identidade = identidade;
}

public String getSexo() {
return sexo;
}

public void setSexo(String sexo) {
this.sexo = sexo;
}

public FglDateTimeYS getDataNascimento() {
return dataNascimento;
}

public void setDataNascimento(FglDateTimeYS dataNascimento) {
this.dataNascimento = dataNascimento;
}

public String getInscricaoEstadual() {
return inscricaoEstadual;
}

public void setInscricaoEstadual(String inscricaoEstadual) {
this.inscricaoEstadual = inscricaoEstadual;
}

public FglDateTimeYS getDataInicioAtividade() {
return dataInicioAtividade;
}

public void setDataInicioAtividade(FglDateTimeYS dataInicioAtividade) {
this.dataInicioAtividade = dataInicioAtividade;
}

public FglDateTimeYS getDataCadastro() {
return dataCadastro;
}

public void setDataCadastro(FglDateTimeYS dataCadastro) {
this.dataCadastro = dataCadastro;
}

public String getStatusCadastro() {
return statusCadastro;
}

public void setStatusCadastro(String statusCadastro) {
this.statusCadastro = statusCadastro;
}

public String getDescCadastro() {
return descCadastro;
}

public void setDescCadastro(String descCadastro) {
this.descCadastro = descCadastro;
}

public String getSsp() {
return ssp;
}

public void setSsp(String ssp) {
this.ssp = ssp;
}

}

