package br.com.linx.sisdia.tabelas;

import br.com.linx.sisdia.Coluna;
import br.com.linx.sisdia.tipos.FglDateTimeHMin;
import br.com.linx.sisdia.tipos.FglDouble;

public class TabLdnParametros {
@Coluna(nome="ldn_parametros.cod_parametro", tipo="int")
private int codParametro;
private boolean codParametroNull;
@Coluna(nome="ldn_parametros.des_empresa", tipo="String")
private String desEmpresa;
@Coluna(nome="ldn_parametros.cod_produto", tipo="String")
private String codProduto;
@Coluna(nome="ldn_parametros.nom_tabela_entrada", tipo="String")
private String nomTabelaEntrada;
@Coluna(nome="ldn_parametros.nom_tabela_saida", tipo="String")
private String nomTabelaSaida;
@Coluna(nome="ldn_parametros.val_intervalo_verificacao", tipo="int")
private int valIntervaloVerificacao;
private boolean valIntervaloVerificacaoNull;
@Coluna(nome="ldn_parametros.qtd_time_out_ws", tipo="int")
private int qtdTimeOutWs;
private boolean qtdTimeOutWsNull;
@Coluna(nome="ldn_parametros.usa_parada_backup", tipo="String")
private String usaParadaBackup;
@Coluna(nome="ldn_parametros.hra_inicio_backup", tipo="FglDateTimeHMin")
private FglDateTimeHMin hraInicioBackup;
@Coluna(nome="ldn_parametros.hra_fim_backup", tipo="FglDateTimeHMin")
private FglDateTimeHMin hraFimBackup;
@Coluna(nome="ldn_parametros.fuso_horario", tipo="int")
private int fusoHorario;
private boolean fusoHorarioNull;
@Coluna(nome="ldn_parametros.schema_xsd", tipo="String")
private String schemaXsd;
@Coluna(nome="ldn_parametros.tipo_integracao", tipo="String")
private String tipoIntegracao;
@Coluna(nome="ldn_parametros.url_mid", tipo="String")
private String urlMid;
@Coluna(nome="ldn_parametros.url_atualizacao", tipo="String")
private String urlAtualizacao;
@Coluna(nome="ldn_parametros.versao_db", tipo="double")
private double versaoDb;
private boolean versaoDbNull;

public TabLdnParametros() {
initialize();
}

public void initialize() {
setCodParametro(null);
setDesEmpresa(null);
setCodProduto(null);
setNomTabelaEntrada(null);
setNomTabelaSaida(null);
setValIntervaloVerificacao(null);
setQtdTimeOutWs(null);
setUsaParadaBackup(null);
setHraInicioBackup(null);
setHraFimBackup(null);
setFusoHorario(null);
setSchemaXsd(null);
setTipoIntegracao(null);
setUrlMid(null);
setUrlAtualizacao(null);
setVersaoDb(null);
}

public TabLdnParametros(int codParametro, String desEmpresa, String codProduto, String nomTabelaEntrada, String nomTabelaSaida, int valIntervaloVerificacao, int qtdTimeOutWs, String usaParadaBackup, FglDateTimeHMin hraInicioBackup, FglDateTimeHMin hraFimBackup, int fusoHorario, String schemaXsd, String tipoIntegracao, String urlMid, String urlAtualizacao, double versaoDb) {
this.codParametro = codParametro;
this.desEmpresa = desEmpresa;
this.codProduto = codProduto;
this.nomTabelaEntrada = nomTabelaEntrada;
this.nomTabelaSaida = nomTabelaSaida;
this.valIntervaloVerificacao = valIntervaloVerificacao;
this.qtdTimeOutWs = qtdTimeOutWs;
this.usaParadaBackup = usaParadaBackup;
this.hraInicioBackup = hraInicioBackup;
this.hraFimBackup = hraFimBackup;
this.fusoHorario = fusoHorario;
this.schemaXsd = schemaXsd;
this.tipoIntegracao = tipoIntegracao;
this.urlMid = urlMid;
this.urlAtualizacao = urlAtualizacao;
this.versaoDb = versaoDb;
}

public int getCodParametro() {
return codParametro;
}

public boolean isCodParametroNull() {
return codParametroNull;
}

public void setCodParametro(Integer codParametro) {
if (codParametro == null) {
codParametroNull = true;
this.codParametro = 0;
} else { 
codParametroNull = false;
this.codParametro = codParametro;
}
}

public String getDesEmpresa() {
return desEmpresa;
}

public void setDesEmpresa(String desEmpresa) {
this.desEmpresa = desEmpresa;
}

public String getCodProduto() {
return codProduto;
}

public void setCodProduto(String codProduto) {
this.codProduto = codProduto;
}

public String getNomTabelaEntrada() {
return nomTabelaEntrada;
}

public void setNomTabelaEntrada(String nomTabelaEntrada) {
this.nomTabelaEntrada = nomTabelaEntrada;
}

public String getNomTabelaSaida() {
return nomTabelaSaida;
}

public void setNomTabelaSaida(String nomTabelaSaida) {
this.nomTabelaSaida = nomTabelaSaida;
}

public int getValIntervaloVerificacao() {
return valIntervaloVerificacao;
}

public boolean isValIntervaloVerificacaoNull() {
return valIntervaloVerificacaoNull;
}

public void setValIntervaloVerificacao(Integer valIntervaloVerificacao) {
if (valIntervaloVerificacao == null) {
valIntervaloVerificacaoNull = true;
this.valIntervaloVerificacao = 0;
} else { 
valIntervaloVerificacaoNull = false;
this.valIntervaloVerificacao = valIntervaloVerificacao;
}
}

public int getQtdTimeOutWs() {
return qtdTimeOutWs;
}

public boolean isQtdTimeOutWsNull() {
return qtdTimeOutWsNull;
}

public void setQtdTimeOutWs(Integer qtdTimeOutWs) {
if (qtdTimeOutWs == null) {
qtdTimeOutWsNull = true;
this.qtdTimeOutWs = 0;
} else { 
qtdTimeOutWsNull = false;
this.qtdTimeOutWs = qtdTimeOutWs;
}
}

public String getUsaParadaBackup() {
return usaParadaBackup;
}

public void setUsaParadaBackup(String usaParadaBackup) {
this.usaParadaBackup = usaParadaBackup;
}

public FglDateTimeHMin getHraInicioBackup() {
return hraInicioBackup;
}

public void setHraInicioBackup(FglDateTimeHMin hraInicioBackup) {
this.hraInicioBackup = hraInicioBackup;
}

public FglDateTimeHMin getHraFimBackup() {
return hraFimBackup;
}

public void setHraFimBackup(FglDateTimeHMin hraFimBackup) {
this.hraFimBackup = hraFimBackup;
}

public int getFusoHorario() {
return fusoHorario;
}

public boolean isFusoHorarioNull() {
return fusoHorarioNull;
}

public void setFusoHorario(Integer fusoHorario) {
if (fusoHorario == null) {
fusoHorarioNull = true;
this.fusoHorario = 0;
} else { 
fusoHorarioNull = false;
this.fusoHorario = fusoHorario;
}
}

public String getSchemaXsd() {
return schemaXsd;
}

public void setSchemaXsd(String schemaXsd) {
this.schemaXsd = schemaXsd;
}

public String getTipoIntegracao() {
return tipoIntegracao;
}

public void setTipoIntegracao(String tipoIntegracao) {
this.tipoIntegracao = tipoIntegracao;
}

public String getUrlMid() {
return urlMid;
}

public void setUrlMid(String urlMid) {
this.urlMid = urlMid;
}

public String getUrlAtualizacao() {
return urlAtualizacao;
}

public void setUrlAtualizacao(String urlAtualizacao) {
this.urlAtualizacao = urlAtualizacao;
}

public double getVersaoDb() {
return versaoDb;
}

public boolean isVersaoDbNull() {
return versaoDbNull;
}

public void setVersaoDb(int versaoDb) {
setVersaoDb(new Double(versaoDb));
}

public void setVersaoDb(long versaoDb) {
setVersaoDb(new Double(versaoDb));
}

public void setVersaoDb(Double versaoDb) {
if (versaoDb == null) {
versaoDbNull = true;
this.versaoDb = 0.;
} else { 
versaoDbNull = false;
this.versaoDb = FglDouble.round(versaoDb, 2);
}
}

}

