package br.com.linx.sisdia.tabelas;

import br.com.linx.sisdia.Coluna;
import br.com.linx.sisdia.tipos.FglDateTimeYS;
import br.com.linx.sisdia.tipos.FglDouble;

public class TabMetComissao {
@Coluna(nome="met_comissao.cpf", tipo="String")
private String cpf;
@Coluna(nome="met_comissao.unidade", tipo="String")
private String unidade;
@Coluna(nome="met_comissao.contrato", tipo="int")
private int contrato;
private boolean contratoNull;
@Coluna(nome="met_comissao.vdb", tipo="int")
private int vdb;
private boolean vdbNull;
@Coluna(nome="met_comissao.tipolancamento", tipo="String")
private String tipolancamento;
@Coluna(nome="met_comissao.datavencimento", tipo="FglDateTimeYS")
private FglDateTimeYS datavencimento;
@Coluna(nome="met_comissao.datalancamento", tipo="FglDateTimeYS")
private FglDateTimeYS datalancamento;
@Coluna(nome="met_comissao.origemlancamento", tipo="String")
private String origemlancamento;
@Coluna(nome="met_comissao.tipoinfolancamento", tipo="String")
private String tipoinfolancamento;
@Coluna(nome="met_comissao.quantidadevalor", tipo="double")
private double quantidadevalor;
private boolean quantidadevalorNull;
@Coluna(nome="met_comissao.lancamentofixo", tipo="String")
private String lancamentofixo;
@Coluna(nome="met_comissao.situacaolancamento", tipo="String")
private String situacaolancamento;
@Coluna(nome="met_comissao.operador", tipo="String")
private String operador;
@Coluna(nome="met_comissao.datahoraalteracao", tipo="FglDateTimeYS")
private FglDateTimeYS datahoraalteracao;
@Coluna(nome="met_comissao.nroprestacao", tipo="int")
private int nroprestacao;
private boolean nroprestacaoNull;
@Coluna(nome="met_comissao.nrototalprestacoes", tipo="int")
private int nrototalprestacoes;
private boolean nrototalprestacoesNull;
@Coluna(nome="met_comissao.descricao250", tipo="String")
private String descricao250;
@Coluna(nome="met_comissao.msgerro", tipo="String")
private String msgerro;

public TabMetComissao() {
initialize();
}

public void initialize() {
setCpf(null);
setUnidade(null);
setContrato(null);
setVdb(null);
setTipolancamento(null);
setDatavencimento(null);
setDatalancamento(null);
setOrigemlancamento(null);
setTipoinfolancamento(null);
setQuantidadevalor(null);
setLancamentofixo(null);
setSituacaolancamento(null);
setOperador(null);
setDatahoraalteracao(null);
setNroprestacao(null);
setNrototalprestacoes(null);
setDescricao250(null);
setMsgerro(null);
}

public TabMetComissao(String cpf, String unidade, int contrato, int vdb, String tipolancamento, FglDateTimeYS datavencimento, FglDateTimeYS datalancamento, String origemlancamento, String tipoinfolancamento, double quantidadevalor, String lancamentofixo, String situacaolancamento, String operador, FglDateTimeYS datahoraalteracao, int nroprestacao, int nrototalprestacoes, String descricao250, String msgerro) {
this.cpf = cpf;
this.unidade = unidade;
this.contrato = contrato;
this.vdb = vdb;
this.tipolancamento = tipolancamento;
this.datavencimento = datavencimento;
this.datalancamento = datalancamento;
this.origemlancamento = origemlancamento;
this.tipoinfolancamento = tipoinfolancamento;
this.quantidadevalor = quantidadevalor;
this.lancamentofixo = lancamentofixo;
this.situacaolancamento = situacaolancamento;
this.operador = operador;
this.datahoraalteracao = datahoraalteracao;
this.nroprestacao = nroprestacao;
this.nrototalprestacoes = nrototalprestacoes;
this.descricao250 = descricao250;
this.msgerro = msgerro;
}

public String getCpf() {
return cpf;
}

public void setCpf(String cpf) {
this.cpf = cpf;
}

public String getUnidade() {
return unidade;
}

public void setUnidade(String unidade) {
this.unidade = unidade;
}

public int getContrato() {
return contrato;
}

public boolean isContratoNull() {
return contratoNull;
}

public void setContrato(Integer contrato) {
if (contrato == null) {
contratoNull = true;
this.contrato = 0;
} else { 
contratoNull = false;
this.contrato = contrato;
}
}

public int getVdb() {
return vdb;
}

public boolean isVdbNull() {
return vdbNull;
}

public void setVdb(Integer vdb) {
if (vdb == null) {
vdbNull = true;
this.vdb = 0;
} else { 
vdbNull = false;
this.vdb = vdb;
}
}

public String getTipolancamento() {
return tipolancamento;
}

public void setTipolancamento(String tipolancamento) {
this.tipolancamento = tipolancamento;
}

public FglDateTimeYS getDatavencimento() {
return datavencimento;
}

public void setDatavencimento(FglDateTimeYS datavencimento) {
this.datavencimento = datavencimento;
}

public FglDateTimeYS getDatalancamento() {
return datalancamento;
}

public void setDatalancamento(FglDateTimeYS datalancamento) {
this.datalancamento = datalancamento;
}

public String getOrigemlancamento() {
return origemlancamento;
}

public void setOrigemlancamento(String origemlancamento) {
this.origemlancamento = origemlancamento;
}

public String getTipoinfolancamento() {
return tipoinfolancamento;
}

public void setTipoinfolancamento(String tipoinfolancamento) {
this.tipoinfolancamento = tipoinfolancamento;
}

public double getQuantidadevalor() {
return quantidadevalor;
}

public boolean isQuantidadevalorNull() {
return quantidadevalorNull;
}

public void setQuantidadevalor(int quantidadevalor) {
setQuantidadevalor(new Double(quantidadevalor));
}

public void setQuantidadevalor(long quantidadevalor) {
setQuantidadevalor(new Double(quantidadevalor));
}

public void setQuantidadevalor(Double quantidadevalor) {
if (quantidadevalor == null) {
quantidadevalorNull = true;
this.quantidadevalor = 0.;
} else { 
quantidadevalorNull = false;
this.quantidadevalor = FglDouble.round(quantidadevalor, 2);
}
}

public String getLancamentofixo() {
return lancamentofixo;
}

public void setLancamentofixo(String lancamentofixo) {
this.lancamentofixo = lancamentofixo;
}

public String getSituacaolancamento() {
return situacaolancamento;
}

public void setSituacaolancamento(String situacaolancamento) {
this.situacaolancamento = situacaolancamento;
}

public String getOperador() {
return operador;
}

public void setOperador(String operador) {
this.operador = operador;
}

public FglDateTimeYS getDatahoraalteracao() {
return datahoraalteracao;
}

public void setDatahoraalteracao(FglDateTimeYS datahoraalteracao) {
this.datahoraalteracao = datahoraalteracao;
}

public int getNroprestacao() {
return nroprestacao;
}

public boolean isNroprestacaoNull() {
return nroprestacaoNull;
}

public void setNroprestacao(Integer nroprestacao) {
if (nroprestacao == null) {
nroprestacaoNull = true;
this.nroprestacao = 0;
} else { 
nroprestacaoNull = false;
this.nroprestacao = nroprestacao;
}
}

public int getNrototalprestacoes() {
return nrototalprestacoes;
}

public boolean isNrototalprestacoesNull() {
return nrototalprestacoesNull;
}

public void setNrototalprestacoes(Integer nrototalprestacoes) {
if (nrototalprestacoes == null) {
nrototalprestacoesNull = true;
this.nrototalprestacoes = 0;
} else { 
nrototalprestacoesNull = false;
this.nrototalprestacoes = nrototalprestacoes;
}
}

public String getDescricao250() {
return descricao250;
}

public void setDescricao250(String descricao250) {
this.descricao250 = descricao250;
}

public String getMsgerro() {
return msgerro;
}

public void setMsgerro(String msgerro) {
this.msgerro = msgerro;
}

}

