package br.com.linx.sisdia.tabelas;

import br.com.linx.sisdia.Coluna;
import br.com.linx.sisdia.tipos.FglDateTimeYS;
import br.com.linx.sisdia.tipos.FglDouble;

public class TabMetContabilizacao {
@Coluna(nome="met_contabilizacao.unidade", tipo="String")
private String unidade;
@Coluna(nome="met_contabilizacao.estabelecimento", tipo="String")
private String estabelecimento;
@Coluna(nome="met_contabilizacao.inscricao", tipo="String")
private String inscricao;
@Coluna(nome="met_contabilizacao.centrocusto", tipo="String")
private String centrocusto;
@Coluna(nome="met_contabilizacao.datalancamento", tipo="FglDateTimeYS")
private FglDateTimeYS datalancamento;
@Coluna(nome="met_contabilizacao.contadebito", tipo="String")
private String contadebito;
@Coluna(nome="met_contabilizacao.contacredito", tipo="String")
private String contacredito;
@Coluna(nome="met_contabilizacao.itemlancamento", tipo="int")
private int itemlancamento;
private boolean itemlancamentoNull;
@Coluna(nome="met_contabilizacao.codigohistorico", tipo="String")
private String codigohistorico;
@Coluna(nome="met_contabilizacao.descricaohistorico", tipo="String")
private String descricaohistorico;
@Coluna(nome="met_contabilizacao.valor", tipo="double")
private double valor;
private boolean valorNull;
@Coluna(nome="met_contabilizacao.codigousuario", tipo="String")
private String codigousuario;
@Coluna(nome="met_contabilizacao.tppessoadebito", tipo="String")
private String tppessoadebito;
@Coluna(nome="met_contabilizacao.cgccpfdebito", tipo="String")
private String cgccpfdebito;
@Coluna(nome="met_contabilizacao.tppessoacredito", tipo="String")
private String tppessoacredito;
@Coluna(nome="met_contabilizacao.cgccpfcredito", tipo="String")
private String cgccpfcredito;
@Coluna(nome="met_contabilizacao.msgerro", tipo="String")
private String msgerro;

public TabMetContabilizacao() {
initialize();
}

public void initialize() {
setUnidade(null);
setEstabelecimento(null);
setInscricao(null);
setCentrocusto(null);
setDatalancamento(null);
setContadebito(null);
setContacredito(null);
setItemlancamento(null);
setCodigohistorico(null);
setDescricaohistorico(null);
setValor(null);
setCodigousuario(null);
setTppessoadebito(null);
setCgccpfdebito(null);
setTppessoacredito(null);
setCgccpfcredito(null);
setMsgerro(null);
}

public TabMetContabilizacao(String unidade, String estabelecimento, String inscricao, String centrocusto, FglDateTimeYS datalancamento, String contadebito, String contacredito, int itemlancamento, String codigohistorico, String descricaohistorico, double valor, String codigousuario, String tppessoadebito, String cgccpfdebito, String tppessoacredito, String cgccpfcredito, String msgerro) {
this.unidade = unidade;
this.estabelecimento = estabelecimento;
this.inscricao = inscricao;
this.centrocusto = centrocusto;
this.datalancamento = datalancamento;
this.contadebito = contadebito;
this.contacredito = contacredito;
this.itemlancamento = itemlancamento;
this.codigohistorico = codigohistorico;
this.descricaohistorico = descricaohistorico;
this.valor = valor;
this.codigousuario = codigousuario;
this.tppessoadebito = tppessoadebito;
this.cgccpfdebito = cgccpfdebito;
this.tppessoacredito = tppessoacredito;
this.cgccpfcredito = cgccpfcredito;
this.msgerro = msgerro;
}

public String getUnidade() {
return unidade;
}

public void setUnidade(String unidade) {
this.unidade = unidade;
}

public String getEstabelecimento() {
return estabelecimento;
}

public void setEstabelecimento(String estabelecimento) {
this.estabelecimento = estabelecimento;
}

public String getInscricao() {
return inscricao;
}

public void setInscricao(String inscricao) {
this.inscricao = inscricao;
}

public String getCentrocusto() {
return centrocusto;
}

public void setCentrocusto(String centrocusto) {
this.centrocusto = centrocusto;
}

public FglDateTimeYS getDatalancamento() {
return datalancamento;
}

public void setDatalancamento(FglDateTimeYS datalancamento) {
this.datalancamento = datalancamento;
}

public String getContadebito() {
return contadebito;
}

public void setContadebito(String contadebito) {
this.contadebito = contadebito;
}

public String getContacredito() {
return contacredito;
}

public void setContacredito(String contacredito) {
this.contacredito = contacredito;
}

public int getItemlancamento() {
return itemlancamento;
}

public boolean isItemlancamentoNull() {
return itemlancamentoNull;
}

public void setItemlancamento(Integer itemlancamento) {
if (itemlancamento == null) {
itemlancamentoNull = true;
this.itemlancamento = 0;
} else { 
itemlancamentoNull = false;
this.itemlancamento = itemlancamento;
}
}

public String getCodigohistorico() {
return codigohistorico;
}

public void setCodigohistorico(String codigohistorico) {
this.codigohistorico = codigohistorico;
}

public String getDescricaohistorico() {
return descricaohistorico;
}

public void setDescricaohistorico(String descricaohistorico) {
this.descricaohistorico = descricaohistorico;
}

public double getValor() {
return valor;
}

public boolean isValorNull() {
return valorNull;
}

public void setValor(int valor) {
setValor(new Double(valor));
}

public void setValor(long valor) {
setValor(new Double(valor));
}

public void setValor(Double valor) {
if (valor == null) {
valorNull = true;
this.valor = 0.;
} else { 
valorNull = false;
this.valor = FglDouble.round(valor, 2);
}
}

public String getCodigousuario() {
return codigousuario;
}

public void setCodigousuario(String codigousuario) {
this.codigousuario = codigousuario;
}

public String getTppessoadebito() {
return tppessoadebito;
}

public void setTppessoadebito(String tppessoadebito) {
this.tppessoadebito = tppessoadebito;
}

public String getCgccpfdebito() {
return cgccpfdebito;
}

public void setCgccpfdebito(String cgccpfdebito) {
this.cgccpfdebito = cgccpfdebito;
}

public String getTppessoacredito() {
return tppessoacredito;
}

public void setTppessoacredito(String tppessoacredito) {
this.tppessoacredito = tppessoacredito;
}

public String getCgccpfcredito() {
return cgccpfcredito;
}

public void setCgccpfcredito(String cgccpfcredito) {
this.cgccpfcredito = cgccpfcredito;
}

public String getMsgerro() {
return msgerro;
}

public void setMsgerro(String msgerro) {
this.msgerro = msgerro;
}

}

