package br.com.linx.sisdia.tabelas;

import br.com.linx.sisdia.Coluna;
import br.com.linx.sisdia.tipos.FglDate;
import br.com.linx.sisdia.tipos.FglDouble;

public class TabSafx100 {
@Coluna(nome="safx100.cod_estado", tipo="String")
private String codEstado;
@Coluna(nome="safx100.ind_produto", tipo="String")
private String indProduto;
@Coluna(nome="safx100.cod_produto", tipo="String")
private String codProduto;
@Coluna(nome="safx100.data_produto", tipo="FglDate")
private FglDate dataProduto;
@Coluna(nome="safx100.dat_vigencia_ini", tipo="FglDate")
private FglDate datVigenciaIni;
@Coluna(nome="safx100.dat_vigencia_fim", tipo="FglDate")
private FglDate datVigenciaFim;
@Coluna(nome="safx100.aliq_icms", tipo="double")
private double aliqIcms;
private boolean aliqIcmsNull;
@Coluna(nome="safx100.perc_base_red_icms", tipo="double")
private double percBaseRedIcms;
private boolean percBaseRedIcmsNull;
@Coluna(nome="safx100.vlr_base_icmss", tipo="double")
private double vlrBaseIcmss;
private boolean vlrBaseIcmssNull;
@Coluna(nome="safx100.datager", tipo="FglDate")
private FglDate datager;

public TabSafx100() {
initialize();
}

public void initialize() {
setCodEstado(null);
setIndProduto(null);
setCodProduto(null);
setDataProduto(null);
setDatVigenciaIni(null);
setDatVigenciaFim(null);
setAliqIcms(null);
setPercBaseRedIcms(null);
setVlrBaseIcmss(null);
setDatager(null);
}

public TabSafx100(String codEstado, String indProduto, String codProduto, FglDate dataProduto, FglDate datVigenciaIni, FglDate datVigenciaFim, double aliqIcms, double percBaseRedIcms, double vlrBaseIcmss, FglDate datager) {
this.codEstado = codEstado;
this.indProduto = indProduto;
this.codProduto = codProduto;
this.dataProduto = dataProduto;
this.datVigenciaIni = datVigenciaIni;
this.datVigenciaFim = datVigenciaFim;
this.aliqIcms = aliqIcms;
this.percBaseRedIcms = percBaseRedIcms;
this.vlrBaseIcmss = vlrBaseIcmss;
this.datager = datager;
}

public String getCodEstado() {
return codEstado;
}

public void setCodEstado(String codEstado) {
this.codEstado = codEstado;
}

public String getIndProduto() {
return indProduto;
}

public void setIndProduto(String indProduto) {
this.indProduto = indProduto;
}

public String getCodProduto() {
return codProduto;
}

public void setCodProduto(String codProduto) {
this.codProduto = codProduto;
}

public FglDate getDataProduto() {
return dataProduto;
}

public void setDataProduto(FglDate dataProduto) {
this.dataProduto = dataProduto;
}

public FglDate getDatVigenciaIni() {
return datVigenciaIni;
}

public void setDatVigenciaIni(FglDate datVigenciaIni) {
this.datVigenciaIni = datVigenciaIni;
}

public FglDate getDatVigenciaFim() {
return datVigenciaFim;
}

public void setDatVigenciaFim(FglDate datVigenciaFim) {
this.datVigenciaFim = datVigenciaFim;
}

public double getAliqIcms() {
return aliqIcms;
}

public boolean isAliqIcmsNull() {
return aliqIcmsNull;
}

public void setAliqIcms(int aliqIcms) {
setAliqIcms(new Double(aliqIcms));
}

public void setAliqIcms(long aliqIcms) {
setAliqIcms(new Double(aliqIcms));
}

public void setAliqIcms(Double aliqIcms) {
if (aliqIcms == null) {
aliqIcmsNull = true;
this.aliqIcms = 0.;
} else { 
aliqIcmsNull = false;
this.aliqIcms = FglDouble.round(aliqIcms, 4);
}
}

public double getPercBaseRedIcms() {
return percBaseRedIcms;
}

public boolean isPercBaseRedIcmsNull() {
return percBaseRedIcmsNull;
}

public void setPercBaseRedIcms(int percBaseRedIcms) {
setPercBaseRedIcms(new Double(percBaseRedIcms));
}

public void setPercBaseRedIcms(long percBaseRedIcms) {
setPercBaseRedIcms(new Double(percBaseRedIcms));
}

public void setPercBaseRedIcms(Double percBaseRedIcms) {
if (percBaseRedIcms == null) {
percBaseRedIcmsNull = true;
this.percBaseRedIcms = 0.;
} else { 
percBaseRedIcmsNull = false;
this.percBaseRedIcms = FglDouble.round(percBaseRedIcms, 4);
}
}

public double getVlrBaseIcmss() {
return vlrBaseIcmss;
}

public boolean isVlrBaseIcmssNull() {
return vlrBaseIcmssNull;
}

public void setVlrBaseIcmss(int vlrBaseIcmss) {
setVlrBaseIcmss(new Double(vlrBaseIcmss));
}

public void setVlrBaseIcmss(long vlrBaseIcmss) {
setVlrBaseIcmss(new Double(vlrBaseIcmss));
}

public void setVlrBaseIcmss(Double vlrBaseIcmss) {
if (vlrBaseIcmss == null) {
vlrBaseIcmssNull = true;
this.vlrBaseIcmss = 0.;
} else { 
vlrBaseIcmssNull = false;
this.vlrBaseIcmss = FglDouble.round(vlrBaseIcmss, 2);
}
}

public FglDate getDatager() {
return datager;
}

public void setDatager(FglDate datager) {
this.datager = datager;
}

}

